unit UnidadCalcularPeriodo;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Mask, DBCtrls, Buttons, Grids, DBGrids;

type
  TformCalcularPeriodo = class(TForm)
    Panel1: TPanel;
    Label3: TLabel;
    BSeleccionarFecha: TSpeedButton;
    BCalcular: TBitBtn;
    Tabla: TDBGrid;
    Panel2: TPanel;
    txtDesdeFecha: TMaskEdit;
    BCancelar: TBitBtn;
    BPasar: TBitBtn;
    Label1: TLabel;
    txtHastaFecha: TMaskEdit;
    BHastaFecha: TSpeedButton;
    BSFechaPago: TSpeedButton;
    txtFechaPago: TMaskEdit;
    Label2: TLabel;
    procedure BSeleccionarFechaClick(Sender: TObject);
    procedure txtDesdeFechaKeyPress(Sender: TObject; var Key: Char);
    procedure Filtro(Sender: TObject);
    procedure txtHorasChange(Sender: TObject);
    procedure BCalcularClick(Sender: TObject);
    procedure calcularBilletes(Cantidad : double);
    procedure BCancelarClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure BPasarClick(Sender: TObject);
    procedure txtHorasKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure BHastaFechaClick(Sender: TObject);
    procedure BSFechaPagoClick(Sender: TObject);
  private
    noAvisar : boolean;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formCalcularPeriodo: TformCalcularPeriodo;

implementation

uses UnidadCalendario, UnidadMenuPrincipal, UnidadDatos, UnidadI, DB;

{$R *.dfm}

procedure TformCalcularPeriodo.BSeleccionarFechaClick(Sender: TObject);
begin
  application.createform(tformCalendario, formCalendario);
  formCalendario.ShowModal;
  if formmenuprincipal.claveelegida <> '' then
    if FormMenuPrincipal.claveelegida <> '' then
      txtDesdeFecha.Text := formmenuprincipal.claveelegida;
end;

procedure TformCalcularPeriodo.txtDesdeFechaKeyPress(Sender: TObject; var Key: Char);
begin
  if FormMenuPrincipal.accion <> 'zoom' then
  begin
    if key = '+' then
    begin
      key := chr(0);
      BHastaFechaClick(nil);
    end;
  end;
end;

procedure TformCalcularPeriodo.Filtro(Sender: TObject);
var
  i : integer;
  aux, aux2, cad : string;
begin
  cad := '0123456789,.'; // Solo se admiten estos caracteres
  aux2:='';
  with (Sender as TEdit) do
  begin
    aux:=text;
    for i:=1 to length(aux) do
      if pos(aux[i],cad)>0 then aux2:=aux2+aux[i];
        text:=aux2;
      SelStart:=length(aux2);
  end;
end;

procedure TformCalcularPeriodo.txtHorasChange(Sender: TObject);
begin
  Filtro(Sender);
end;

procedure TformCalcularPeriodo.calcularBilletes(Cantidad : double);
var
  C : array[1..15] of double;
  S : array[1..15] of double;
  i : integer;
begin
  try
    c[1] := 50000;
    c[2] := 20000;
    c[3] := 10000;
    c[4] := 5000;
    c[5] := 2000;
    c[6] := 1000;
    c[7] := 500;
    c[8] := 200;
    c[9] := 100;
    c[10] := 50;
    c[11] := 20;
    c[12] := 10;
    c[13] := 5;
    c[14] := 2;
    c[15] := 1;

    //Pasa el total a pagar a cntimos
    cantidad := cantidad * 100;
    cantidad := int(cantidad);
    for i := 1 to 15 do
    begin
      s[i] := int(cantidad / c[i]);
      cantidad := cantidad - s[i] * c[i];
    end;
    Datos.TPagosTemporal.FieldByName('1C').value := s[15];
    Datos.TPagosTemporal.FieldByName('2C').value := s[14];
    Datos.TPagosTemporal.FieldByName('5C').value := s[13];
    Datos.TPagosTemporal.FieldByName('10C').value := s[12];
    Datos.TPagosTemporal.FieldByName('20C').value := s[11];
    Datos.TPagosTemporal.FieldByName('50C').value := s[10];
    Datos.TPagosTemporal.FieldByName('1E').value := s[9];
    Datos.TPagosTemporal.FieldByName('2E').value := s[8];
    Datos.TPagosTemporal.FieldByName('5E').value := s[7];
    Datos.TPagosTemporal.FieldByName('10E').value := s[6];
    Datos.TPagosTemporal.FieldByName('20E').value := s[5];
    Datos.TPagosTemporal.FieldByName('50E').value := s[4];
    Datos.TPagosTemporal.FieldByName('100E').value := s[3];
    Datos.TPagosTemporal.FieldByName('200E').value := s[2];
    Datos.TPagosTemporal.FieldByName('500E').value := s[1];
  except
    //Silenciosa
  end;
end;

procedure TformCalcularPeriodo.BCalcularClick(Sender: TObject);
var
  horas, precioHora, sueldo : double;
begin
  if Datos.TPagosTemporal.RecordCount > 0 then
  begin
    if MessageDlg('Desea recalcular los obreros existentes?',
        mtConfirmation,[mbyes,mbno],0)=mrYes then
    begin
      Screen.Cursor := crHourGlass;
      formi.L.Caption := 'Recalculando existentes, espere por favor...';
      formi.B.Visible := true;
      formi.B.Position := 0;
      formi.B.Min := 0;
      formi.Show;
      formi.Refresh;
      try
        formi.B.Max := Datos.TPagosTemporal.RecordCount;
        Datos.TPagosTemporal.First;
        while not Datos.TPagosTemporal.Eof do
        begin
          formi.B.Position := Datos.TPagosTemporal.RecNo;
          if varisnull(Datos.TPagosTemporalPRECIOHORA.Value) then
            precioHora := 0
          else
            precioHora := Datos.TPagosTemporalPRECIOHORA.Value;
          if varisnull(Datos.TPagosTemporalHORAS.Value) then
            horas := 0
          else
            horas := Datos.TPagosTemporalHORAS.Value;
          if varisnull(Datos.TPagosTemporalSUELDO.Value) then
            sueldo := 0
          else
            sueldo := Datos.TPagosTemporalSUELDO.Value;
          if (precioHora <> 0) and (horas <> 0) then
              sueldo := horas * precioHora;
          datos.TPagosTemporal.Edit;
          datos.TPagosTemporalBILLETES.Value := formMenuPrincipal.calcularBilletes(sueldo);
          datos.TPagosTemporalpreciohora.Value := precioHora;
          datos.TPagosTemporalhoras.Value := Horas;
          datos.TPagosTemporalSueldo.Value := sueldo;
          calcularBilletes(sueldo);
          Datos.TPagosTemporal.Post;
          datos.TPagosTemporal.Next;
        end;
      except
        formi.Close;
        screen.Cursor := crDefault;
        raise;
        exit;
      end;
      formi.Close;
      screen.Cursor := crDefault;
      exit;
    end;
  end;

  //NUEVO CALCULO
  Screen.Cursor := crHourGlass;
  formi.L.Caption := 'Realizando clculos, espere por favor...';
  formi.B.Visible := true;
  formi.B.Position := 0;
  formi.B.Min := 0;
  formi.Show;
  formi.Refresh;
  try
    Datos.TPagosTemporal.Open;
    Datos.TPagosTemporal.First;
    while not datos.TPagosTemporal.Eof do
      datos.TPagosTemporal.Delete;
    Datos.TEmpleado.Open;
    formi.B.Max := Datos.TEmpleado.RecordCount;
    datos.TEmpleado.First;
    datos.tc.Close;
    datos.TC.DatabaseName := 'Pagos';
    datos.tc.sql.clear;
    datos.TC.SQL.Add('select d.CodigoEmpleado, SUM(d.Importe) ImporteTotal, SUM(d.Horas) TotalHoras');
    datos.TC.SQL.Add('from ' + ctDetallePartes + ' d');
    datos.TC.SQL.Add('where d.CodigoParte IN (');
    datos.TC.SQL.Add('select p.Codigo');
    datos.TC.SQL.Add('from ' + ctPartes + ' p');
    datos.TC.SQL.Add('where p.Fecha between :pfDesde and :pfHasta)');
    datos.TC.SQL.Add('group by d.CodigoEmpleado');
    datos.TC.ParamByName('pfDesde').DataType := ftdate;
    datos.TC.ParamByName('pfDesde').Value := strtodate(txtDesdeFecha.Text);
    datos.TC.ParamByName('pfHasta').DataType := ftdate;
    datos.TC.ParamByName('pfHasta').Value := strtodate(txtHastaFecha.Text);
    try
      datos.tc.open;
    except
      formi.Close;
      screen.Cursor := crDefault;
      datos.tc.close;
      raise;
      exit;
    end;
    while not Datos.TC.Eof do
    begin
      formi.B.Position := datos.tc.RecNo;
      if varisnull(Datos.Tc.fieldbyname('ImporteTotal').Value) then
        sueldo := 0
      else
        sueldo := Datos.Tc.fieldbyname('ImporteTotal').Value;
      if varisnull(Datos.Tc.fieldbyname('TotalHoras').Value) then
        horas := 0
      else
        horas := Datos.Tc.fieldbyname('TotalHoras').Value;
      datos.TPagosTemporal.Insert;
      datos.TPagosTemporalBILLETES.Value := formMenuPrincipal.calcularBilletes(sueldo);
      datos.TPagosTemporalhoras.Value := Horas; 
      datos.TPagosTemporalSueldo.Value := sueldo;
      datos.TPagosTemporalFECHAPAGO.Value := StrToDate(txtfechapago.Text);
      datos.TPagosTemporalCodigoEmpleado.Value :=
          datos.TC.fieldbyname('CodigoEmpleado').value;
      calcularBilletes(sueldo);
      Datos.TPagosTemporal.Post;
      datos.Tc.Next;
    end;
  except
    formi.Close;
    screen.Cursor := crDefault;
    datos.tc.close;
    raise;
  end;
  datos.tc.close;
  datos.TC.DatabaseName := '';
  Tabla.Refresh;
  formi.Close;
  screen.Cursor := crDefault;
end;

procedure TformCalcularPeriodo.BCancelarClick(Sender: TObject);
begin
  close;
end;

procedure TformCalcularPeriodo.FormShow(Sender: TObject);
begin
  Datos.TPagosTemporal.Open;
  txtDesdeFecha.SetFocus;
  txtDesdeFecha.Text := DateToStr(date);
  txtHastaFecha.Text := DateToStr(date);
  txtFechaPago.Text := DateToStr(date);    
  while not datos.TPagosTemporal.Eof do
    datos.TPagosTemporal.Delete;
end;

procedure TformCalcularPeriodo.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if not noAvisar then
  begin
    if Datos.TPagosTemporal.RecordCount > 0 then
    begin
      if MessageDlg('Atencin: va a deshacer las modificaciones. Si pulsa "Aceptar" ' +
          'los clculos realizados NO sern guardados.',
          mtwarning, [mbok, mbcancel], 0) = mrcancel then
        Action := canone;
        exit;
    end;
  end;
  datos.TPagosTemporal.Close;
  datos.TEmpleado.Close;
  Datos.TPagos.Close;
  action := caFree;
end;

procedure TformCalcularPeriodo.FormCreate(Sender: TObject);
begin
  Datos.TEmpleado.Open;
end;

procedure TformCalcularPeriodo.BPasarClick(Sender: TObject);
begin
  if MessageDlg('Se van a guardar los clculos realizados en pagos a ' +
      'empleados. Pulse "Aceptar" para continuar.',
      mtinformation, [mbok, mbcancel], 0) = mrok then
  begin
    Screen.Cursor := crHourGlass;
    formi.L.Caption := 'Guardando clculos, espere por favor...';
    formi.B.Visible := true;
    formi.B.Position := 0;
    formi.B.Min := 0;
    formi.Show;
    formi.Refresh;
    try
      Datos.TPagos.Open;
      datos.TPagosTemporal.First;
      formi.B.Max := datos.TPagosTemporal.RecordCount;
      while not Datos.TPagosTemporal.Eof do
      begin
        formi.B.Position := Datos.TPagosTemporal.RecNo;
        datos.TPagos.Insert;
        datos.TPagosSUELDO.Value := datos.TPagosTemporalSUELDO.Value;
        datos.TPagosBILLETES.Value := datos.TPagosTemporalBILLETES.Value;
        datos.TPagosPRECIOHORA.Value := datos.TPagosTemporalpreciohora.Value;
        datos.TPagosHORAS.Value := datos.TPagosTemporalhoras.Value;
        datos.TPagosFECHAPAGO.Value :=  datos.TPagosTemporalFECHAPAGO.Value;
        datos.TPagosCODIGOEMPLEADO.Value := datos.TPagosTemporalCodigoEmpleado.Value;
        datos.TPagosBDEDesigner1C.Value := datos.TPagosTemporalBDEDesigner1C.Value;
        datos.TPagosBDEDesigner2C.Value := datos.TPagosTemporalBDEDesigner2C.Value;
        datos.TPagosBDEDesigner5C.Value := datos.TPagosTemporalBDEDesigner5C.Value;
        datos.TPagosBDEDesigner10C.Value := datos.TPagosTemporalBDEDesigner10C.Value;
        datos.TPagosBDEDesigner20C.Value := datos.TPagosTemporalBDEDesigner20C.Value;
        datos.TPagosBDEDesigner50C.Value := datos.TPagosTemporalBDEDesigner50C.Value;
        datos.TPagosBDEDesigner1E.Value := datos.TPagosTemporalBDEDesigner1E.Value;
        datos.TPagosBDEDesigner2E.Value := datos.TPagosTemporalBDEDesigner2E.Value;
        datos.TPagosBDEDesigner5E.Value := datos.TPagosTemporalBDEDesigner5E.Value;
        datos.TPagosBDEDesigner10E.Value := datos.TPagosTemporalBDEDesigner10E.Value;
        datos.TPagosBDEDesigner20E.Value := datos.TPagosTemporalBDEDesigner20E.Value;
        datos.TPagosBDEDesigner50E.Value := datos.TPagosTemporalBDEDesigner50E.Value;
        datos.TPagosBDEDesigner100E.Value := datos.TPagosTemporalBDEDesigner100E.Value;
        datos.TPagosBDEDesigner200E.Value := datos.TPagosTemporalBDEDesigner200E.Value;
        datos.TPagosBDEDesigner500E.Value := datos.TPagosTemporalBDEDesigner500E.Value;
        Datos.TPagos.Post;
        datos.TPagosTemporal.Next;
      end;
    except
      formi.Close;
      screen.Cursor := crDefault;
      raise;
    end;
    formi.Close;
    screen.Cursor := crDefault;
    noavisar := true;
    close;
  end;
end;

procedure TformCalcularPeriodo.txtHorasKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Key = '.' then
    key := ',';
end;

procedure TformCalcularPeriodo.FormKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Key = #13 then
  begin
    Key := #0;
    Perform(WM_NEXTDLGCTL, 0, 0);
  end;
end;

procedure TformCalcularPeriodo.BHastaFechaClick(Sender: TObject);
begin
  application.createform(tformCalendario, formCalendario);
  formCalendario.ShowModal;
  if formmenuprincipal.claveelegida <> '' then
    if FormMenuPrincipal.claveelegida <> '' then
      txtHastaFecha.Text := formmenuprincipal.claveelegida;
end;

procedure TformCalcularPeriodo.BSFechaPagoClick(Sender: TObject);
begin
  application.createform(tformCalendario, formCalendario);
  formCalendario.ShowModal;
  if formmenuprincipal.claveelegida <> '' then
    if FormMenuPrincipal.claveelegida <> '' then
      txtFechaPago.Text := formmenuprincipal.claveelegida;
end;

end.
