unit UnidadCargas;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Mask, Buttons, ExtCtrls, DB, DBTables, Grids, DBGrids,
  ADODB, KDaoTable, KDaoDataBase, ComCtrls, DBCtrls;

type
  TFormCargas = class(TForm)
    dialogo: TOpenDialog;
    dd: TDataSource;
    DB: TKADaoDatabase;
    TC: TKADaoTable;
    Tab: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    opQuincena: TCheckBox;
    opObreros: TCheckBox;
    txtQuincena: TEdit;
    txtObrero: TEdit;
    GroupBox2: TGroupBox;
    txtRuta: TEdit;
    Button1: TButton;
    GroupBox3: TGroupBox;
    opAccess: TRadioButton;
    opParadox: TRadioButton;
    opDBase: TRadioButton;
    RadioButton1: TRadioButton;
    GroupBox5: TGroupBox;
    opCargarNuevos: TCheckBox;
    opActualizarExistentes: TCheckBox;
    opActualizarNombre: TCheckBox;
    BPrecarga: TBitBtn;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Panel1: TPanel;
    Button2: TButton;
    txtErrores: TMemo;
    TabSheet3: TTabSheet;
    txtInfo: TMemo;
    GroupBox4: TGroupBox;
    txtCuadrilla: TDBLookupComboBox;
    GroupBox6: TGroupBox;
    txtFechaPago: TMaskEdit;
    Label3: TLabel;
    Label4: TLabel;
    txtPeriodo: TEdit;
    Panel2: TPanel;
    BGuardarErrores: TBitBtn;
    BitBtn4: TBitBtn;
    DLGuardar: TSaveDialog;
    procedure Button1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BPrecargaClick(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);

    function actCampo(tablaBD : ttable; campo : string; tabla : string; numero : boolean) : boolean;
    function comIntegProd (campo : string; tabla : ttable) : boolean;
    function PrepararTC(cargar : boolean; tabla : string) : string;
    function EsNumero (num : string) : boolean;
    procedure calcularBilletes(Cantidad : double);
    function Redondear (Numero : Double; PrecisionDec : byte) : double;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure txtQuincenaChange(Sender: TObject);
    procedure txtObreroChange(Sender: TObject);
    procedure txtRutaChange(Sender: TObject);
    procedure opQuincenaClick(Sender: TObject);
    procedure opObrerosClick(Sender: TObject);
    procedure txtRutaMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure txtFechaPagoChange(Sender: TObject);
    procedure txtPeriodoChange(Sender: TObject);
    procedure BGuardarErroresClick(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormCargas: TFormCargas;

implementation

uses UnidadI, UnidadDatos, UnidadMenuPrincipal;

{$R *.dfm}

procedure TFormCargas.Button1Click(Sender: TObject);
begin
  if dialogo.Execute then
    txtruta.Text := dialogo.FileName;
end;

procedure TFormCargas.BitBtn1Click(Sender: TObject);
begin
  close;
end;

function TFormCargas.PrepararTC (cargar : boolean; tabla : string) : string;
var
  numeroCargados : integer;
begin
  numeroCargados := 0;
  TC.Close;
  TC.SQL.Clear;
  //Para diferentes formatos de bases de datos
  if opAccess.Checked then
  begin
    try
     DB.Close;
     DB.database := txtruta.Text;
     DB.Open;
    except
      raise
    end;
    TC.Database := DB;
  end;  
  if not cargar then
  begin
    TC.sql.Add('SELECT *');
    TC.SQL.Add('FROM ' + tabla);
    try
      TC.open;
    except
      formi.close;
      result := '';
      raise;
    end;
    numeroCargados := TC.RecordCount;
  end
  else
  begin
    TC.Close;
    TC.SQL.Clear;
    TC.sql.Add('SELECT *');
    TC.SQL.Add('FROM ' + tabla);
    try
      TC.open;
    except
      formi.close;
      result := '';
      raise;
    end;
  end;
  result := ' **' + UpperCase(tabla) + ': ' +  inttostr(numeroCargados);
end;



procedure TFormCargas.BPrecargaClick(Sender: TObject);
var
  mensaje : string;
begin
  BitBtn2.Enabled := false;
  if (txtFechaPago.Text = '') or (txtfechapago.text = '  /  /  ') then
  begin
    MessageDlg ('Debe seleccionar una fecha de pago.', mtinformation, [mbok],0);
    txtfechapago.SetFocus;
    exit;
  end;
  if txtPeriodo.Text = '' then
  begin
    MessageDlg ('Debe seleccionar un perodo de pago.', mtinformation, [mbok],0);
    txtPeriodo.SetFocus;
    exit;
  end;
  if datos.TCuadrilla.RecordCount <= 0 then
  begin
    MessageDlg ('Debe aadir una cuadrilla para asignrsela a la carga.', mtinformation, [mbok],0);
    exit;
  end;
  if (txtcuadrilla.KeyValue = '') or (txtcuadrilla.keyvalue = null) then
  begin
    MessageDlg ('Debe seleccionar una cuadrilla para asignrsela a la carga.', mtinformation, [mbok],0);
    txtcuadrilla.SetFocus;
    exit;
  end;

  if not FileExists(txtruta.Text) then
  begin
    messagedlg('El fichero seleccionado para la carga de gastos externa: ' +
        txtruta.text +
        ' no existe. Compruebe la ruta seleccionada y vuelva a intentarlo.'
         , mtError,[mbok],0);
    exit;
  end;
  if opQuincena.Checked then
  begin
    mensaje := PrepararTC (false, txtQuincena.Text);
    try
      tc.FieldByName('CODIGO').Value;
    except
      messagedlg('No existe el campo CODIGO en la tabla: ' +
          txtQuincena.Text, mterror,[mbok],0);
      exit;
    end;
    try
      tc.FieldByName('NOMBRE').Value;
    except
      messagedlg('No existe el campo NOMBRE en la tabla: ' +
          txtQuincena.Text, mterror,[mbok],0);
      exit;
    end;
    try
      tc.FieldByName('HORAS').Value;
    except
      messagedlg('No existe el campo HORAS en la tabla: ' +
          txtQuincena.Text, mterror,[mbok],0);
      exit;
    end;
    try
      tc.FieldByName('IMPORTE').Value;
    except
      messagedlg('No existe el campo IMPORTE en la tabla: ' +
          txtQuincena.Text, mterror,[mbok],0);
      exit;
    end;
  end;
  if opObreros.Checked then
  begin
    mensaje := mensaje + PrepararTC (false, txtObrero.Text);
    try
      tc.FieldByName('CODIGO').Value;
    except
      messagedlg('No existe el campo CODIGO en la tabla: ' +
          txtObrero.Text, mterror,[mbok],0);
      exit;
    end;
    try
      tc.FieldByName('NOMBRE').Value;
    except
      messagedlg('No existe el campo NOMBRE en la tabla: ' +
          txtObrero.Text, mterror,[mbok],0);
      exit;
    end;
    try
      tc.FieldByName('NIF').Value;
    except
      messagedlg('No existe el campo NIF en la tabla: ' +
          txtObrero.Text, mterror,[mbok],0);
      exit;
    end;
  end;
  messagedlg('La carga seleccionada tiene los siguientes datos:' + chr(13) +
      chr(13) + mensaje, mtinformation,[mbok],0);
  BitBtn2.Enabled := true;
end;

function tformcargas.comIntegProd (campo : string; tabla : ttable) : boolean;
begin
  if not varisnull(tc.fieldbyname(Campo).Value) then
  begin
    if not tabla.Locate('Codigo', tc.fieldbyname(campo).Value, []) then
    begin
      txterrores.Lines.Add('ERROR: PRODUCTO [' +
          tc.fieldbyname('Codigo').value + '] no se ha aadido: campo ' + campo + ' [' +
          tc.fieldbyname(campo).Value + '] no existente.');
      result := false;
    end
    else
      result := true;
  end
  else
  begin
    txterrores.Lines.Add('ERROR: PRODUCTO [' +
        tc.fieldbyname('Codigo').value + '] no se ha aadido: campo ' + campo + ' vaco.');
    result := false;
  end;
  refresh;
end;

function tformcargas.actCampo(tablaBD : ttable; campo : string; tabla : string; numero : boolean) : boolean;
var
  valorStr : string;
  valorNum : double;
begin
  if not varisnull(tc.fieldbyname(campo).value) then
  begin
    if (tablabd.FieldByName(campo).Value <> tc.fieldbyname(campo).value) then
    begin
      if numero then
      begin
        if tablabd.FieldByName(campo).Value = null then
          valorNum := 0
        else
          valornum := tablabd.FieldByName(campo).Value;
        txtinfo.Lines.Add(Tabla + ' [' +
            tc.fieldbyname('Codigo').value + '] ' + UpperCase(campo) + ' actualizado: de [' +
            floattostr(valorNum) + '] a [' +
            floattostr(tc.fieldbyname(campo).value) + ']');
      end
      else
      begin
        if tablabd.FieldByName(campo).Value = null then
          valorStr := ''
        else
          valorStr := tablabd.FieldByName(campo).Value;
        txtinfo.Lines.Add(Tabla + ' [' +
            tc.fieldbyname('Codigo').value + '] ' + uppercase(campo) + ' actualizado: de [' +
            valorStr + '] a [' +
            tc.fieldbyname(campo).value + ']');
      end;
      tablabd.FieldByName(campo).Value := tc.fieldbyname(campo).value;
      result := true;
    end
    else
      result := false;
  end
  else
    result := false;
end;

function TFormCargas.EsNumero (num : string) : boolean;
begin
  try
    strtofloat(num);
    result := true;
  except
    result := false;
  end;
end;

procedure TFormCargas.calcularBilletes(Cantidad : double);
var
  C : array[1..15] of double;
  S : array[1..15] of double;
  i : integer;
begin
  try
    c[1] := 50000;
    c[2] := 20000;
    c[3] := 10000;
    c[4] := 5000;
    c[5] := 2000;
    c[6] := 1000;
    c[7] := 500;
    c[8] := 200;
    c[9] := 100;
    c[10] := 50;
    c[11] := 20;
    c[12] := 10;
    c[13] := 5;
    c[14] := 2;
    c[15] := 1;

    //Pasa el total a pagar a cntimos
    cantidad := cantidad * 100;
    cantidad := int(cantidad);
    for i := 1 to 15 do
    begin
      s[i] := int(cantidad / c[i]);
      cantidad := cantidad - s[i] * c[i];
    end;
    Datos.TPagos.FieldByName('1C').value := s[15];
    Datos.TPagos.FieldByName('2C').value := s[14];
    Datos.TPagos.FieldByName('5C').value := s[13];
    Datos.TPagos.FieldByName('10C').value := s[12];
    Datos.TPagos.FieldByName('20C').value := s[11];
    Datos.TPagos.FieldByName('50C').value := s[10];
    Datos.TPagos.FieldByName('1E').value := s[9];
    Datos.TPagos.FieldByName('2E').value := s[8];
    Datos.TPagos.FieldByName('5E').value := s[7];
    Datos.TPagos.FieldByName('10E').value := s[6];
    Datos.TPagos.FieldByName('20E').value := s[5];
    Datos.TPagos.FieldByName('50E').value := s[4];
    Datos.TPagos.FieldByName('100E').value := s[3];
    Datos.TPagos.FieldByName('200E').value := s[2];
    Datos.TPagos.FieldByName('500E').value := s[1];
  except
    //Silenciosa
  end;
end;


function TFormCargas.Redondear (Numero : Double; PrecisionDec : byte) : double;
  function Potencia(Base : Double; Exponente : byte) : Double;
  begin
    Result := Exp(Exponente * ln(Base));
  end;
begin
  result := Round(Numero * Potencia(10, PrecisionDec)) / Potencia (10, PrecisionDec);
end;

procedure TFormCargas.BitBtn2Click(Sender: TObject);
var
  numero, numDupli, numDupliNoCargados, numNuevos, total : integer;
  textoMensaje, codigo, hora, horaNueva : string;
begin
  txterrores.Clear;
  txtInfo.Clear;
  TabSheet2.Show;
  try
    formi.L.Caption := 'Importando datos...';
    formi.B.Visible := true;
    formi.B.Position := 0;
    formi.B.Min := 0;
    formi.Show;
    formi.Refresh;
    //Obreros
    if opObreros.Checked then
    begin
      formi.L.Caption := 'Importando OBREROS...';
      PrepararTC(true, txtObrero.Text);
      datos.TEmpleado.Filtered := false;
      datos.TEmpleado.Open;
      tc.First;
      total := tc.recordcount;
      formi.B.Max := total;
      numero := 1;
      numDupliNoCargados := 0;
      numNuevos := 0;
      numDupli := 0;
      while not TC.Eof do
      begin
        formi.B.Position := numero;
        formi.L.Caption := 'Importando OBRERO: ' + inttostr(numero);
        if varisnull(tc.FieldByName('Codigo').Value) then
            txterrores.Lines.Add('ERROR: OBRERO no aadido: cdigo vaco. Posicin: ' + inttostr(numero))
        else
        begin
          //Si ya existe
          if tc.FieldByName('Codigo').DataType <> ftstring then
            codigo := inttostr(tc.FieldByName('Codigo').Value)
          else
            codigo := tc.FieldByName('Codigo').Value;
          if datos.TEmpleado.Locate('Codigo', codigo,[]) then
          begin
            // s actualizar existentes
            if opActualizarExistentes.Checked then
            begin
              datos.TEmpleado.edit;
              if opActualizarNombre.Checked then
              begin
                if actCampo(datos.TEmpleado, 'NOMBRE', 'OBRERO', false) then
                  numDupli := numDupli + 1;
              end;
              actCampo(datos.TEmpleado, 'NIF', 'OBRERO', false);
              datos.TEmpleado.post;
            end
            else //Duplicado que no se cargar
              numDupliNoCargados := numDupliNoCargados + 1;
          end
          else //Si es nuevo
          begin
            if varisnull(TC.FieldByName('Nombre').Value) then
              txterrores.Lines.Add('ERROR: OBRERO [' +
                  codigo + '] no se ha aadido: Nombre vaco')
            else
            begin
              datos.TEmpleado.insert;
              datos.TEmpleadoCodigo.Value := codigo;
              datos.TEmpleadoNombre.Value := tc.fieldbyname('Nombre').Value;
              if not varisnull(tc.fieldbyname('NIF').Value) then
                datos.TEmpleadoNIF.Value := tc.fieldbyname('NIF').Value;
              datos.TEmpleadoCodigoCuadrilla.Value := txtCuadrilla.KeyValue;
              datos.TEmpleado.post;
              numNuevos := numNuevos + 1;
            end;
          end;
        end;
        tc.Next;
        numero := numero + 1;
      end;
      textoMensaje := ' ** OBRERO: ' +
          chr(13) + '    Total registros de la carga externa: ' + inttostr (total) +
          chr(13) + '    Total nuevos cargados: ' + inttostr(numNuevos) +
          chr(13) + '    Total existentes actualizados: ' + inttostr(numDupli) +
          chr(13) + '    Total existentes no actualizados: ' + inttostr(numDupliNoCargados);
    end;

    //QUINCENA
    if opQuincena.Checked then
    begin
      formi.L.Caption := 'Importando PAGOS...';
      PrepararTC(true, txtQuincena.Text);
      datos.TPagos.Filtered := false;
      datos.TPagos.Open;
      datos.TEmpleado.Filtered := false;
      datos.TEmpleado.Open;
      tc.First;
      total := tc.recordcount;
      formi.B.Max := total;
      numero := 1;
      numDupliNoCargados := 0;
      numNuevos := 0;
      numDupli := 0;
      while not TC.Eof do
      begin
        formi.B.Position := numero;
        formi.L.Caption := 'Importando PAGO: ' + inttostr(numero);
        if varisnull(tc.FieldByName('Codigo').Value) then
            txterrores.Lines.Add('ERROR: PAGO no aadido: cdigo obrero vaco. Posicin: ' + inttostr(numero))
        else
        begin
          if tc.FieldByName('Codigo').DataType <> ftstring then
            codigo := inttostr(tc.FieldByName('Codigo').Value)
          else
            codigo := tc.FieldByName('Codigo').Value;
          //si no existe el obrero en obreros aadir
          if not datos.TEmpleado.Locate('Codigo', codigo,[]) then
          begin
            datos.TEmpleado.Insert;
            datos.TEmpleadoCodigo.Value := codigo;
            if not varisnull(tc.fieldbyname('Nombre').Value) then
              datos.TEmpleadoNOMBRE.Value := tc.fieldbyname('Nombre').Value
            else
              datos.TEmpleadoNOMBRE.Value := 'Sin nombre';
            datos.TEmpleadoCodigoCuadrilla.Value := txtcuadrilla.KeyValue;
          end;
          //Si ya existe
          if datos.TPagos.Locate('FechaPago;CodigoEmpleado',
              vararrayof([txtfechapago.text,codigo]),[]) then
          begin
            // s actualizar existentes
            if opActualizarExistentes.Checked then
            begin
              numDupli := numDupli + 1;
              datos.TPagos.edit;
              datos.TPagosPERIODO.Value := txtPeriodo.Text;
              if not varisnull(tc.fieldbyname('Importe').Value) then
              begin
                if esnumero(tc.fieldbyname('Importe').Value) then
                  datos.TPagosSUELDO.Value := redondear(tc.fieldbyname('Importe').Value,2)
                else
                begin
                  txterrores.Lines.Add('ATENCIN: PAGO -> Formato de IMPORTE no vlido. Cdigo obrero: ' + codigo);
                  datos.TPagosSUELDO.Value := 0;
                end;
              end
              else
              begin
                txterrores.Lines.Add('ATENCIN: PAGO -> IMPORTE vaco. Cdigo obrero: ' + codigo);
                datos.TPagosSUELDO.Value := 0;
              end;
              //HORAS
              if not varisnull(tc.fieldbyname('Horas').Value) then
                hora := tc.fieldbyname('Horas').Value
              else
                hora := '0';
              if hora <> '0' then
              begin
                horaNueva := trim(copy(hora, 1, pos(':', hora) - 1));
                if copy(hora, pos(':', hora) + 2, 1) = '3' then
                  horanueva := horanueva + ',5';
                hora := trim(horanueva);
              end;
              if esNumero(hora) then
                datos.TPagosHORAS.Value := strtofloat(hora)
              else
              begin
                txterrores.Lines.Add('ATENCIN: PAGO -> Formato de HORA no vlido. Cdigo obrero: ' + codigo);
                datos.TPagosHORAS.Value := 0;
              end;
              datos.TPagosBILLETES.Value :=
                  formMenuPrincipal.calcularBilletes(datos.TPagosSUELDO.Value);
              calcularBilletes(datos.TPagosSUELDO.Value);
              datos.TPagos.post;
            end
            else //Duplicado que no se cargar
              numDupliNoCargados := numDupliNoCargados + 1;
          end
          else //Si es nuevo
          begin
            datos.TPagos.insert;
            datos.TPagosCODIGOEMPLEADO.Value := codigo;
            datos.TPagosPERIODO.Value := txtPeriodo.Text;
            datos.TPagosFECHAPAGO.Value := strtodate(txtFechaPago.Text);
            //Comprobar nombre de pagos con nombre de empleado
            //No terminado
            if not varisnull(tc.fieldbyname('Importe').Value) then
            begin
              if esnumero(tc.fieldbyname('Importe').Value) then
                datos.TPagosSUELDO.Value := redondear(tc.fieldbyname('Importe').Value,2)
              else
              begin
                txterrores.Lines.Add('ATENCIN: PAGO -> Formato de IMPORTE no vlido. Cdigo obrero: ' + codigo);
                datos.TPagosSUELDO.Value := 0;
              end;
            end
            else
            begin
              txterrores.Lines.Add('ATENCIN: PAGO -> IMPORTE vaco. Cdigo obrero: ' + codigo);
              datos.TPagosSUELDO.Value := 0;
            end;
            //HORAS
            if not varisnull(tc.fieldbyname('Horas').Value) then
              hora := tc.fieldbyname('Horas').Value
            else
              hora := '0';
            if hora <> '0' then
            begin
              horaNueva := trim(copy(hora, 1, pos(':', hora) - 1));
              if copy(hora, pos(':', hora) + 2, 1) = '3' then
                horanueva := horanueva + ',5';
              hora := trim(horanueva);
            end;
            if esNumero(hora) then
              datos.TPagosHORAS.Value := strtofloat(hora)
            else
            begin
              txterrores.Lines.Add('ATENCIN: PAGO -> Formato de HORA no vlido. Cdigo obrero: ' + codigo);
              datos.TPagosHORAS.Value := 0;
            end;
            datos.TPagosBILLETES.Value :=
                formMenuPrincipal.calcularBilletes(datos.TPagosSUELDO.Value);
            calcularBilletes(datos.TPagosSUELDO.Value);
            datos.TPagos.post;
            numNuevos := numNuevos + 1;
          end;
        end;
        tc.Next;
        numero := numero + 1;
      end;
      if textomensaje <> '' then
        textomensaje := textomensaje + chr(13) + chr(13);
      textoMensaje := textomensaje + ' ** PAGOS: ' +
          chr(13) + '    Total registros de la carga externa: ' + inttostr (total) +
          chr(13) + '    Total nuevos cargados: ' + inttostr(numNuevos) +
          chr(13) + '    Total existentes actualizados: ' + inttostr(numDupli) +
          chr(13) + '    Total existentes no actualizados: ' + inttostr(numDupliNoCargados);
    end;


  except
    formi.Close;
    tc.Close;
    raise;
    exit;
  end;
  formi.Close;
  MessageDlg('La carga ha finalizado correctamente:' + chr(13) +
      textomensaje, mtInformation, [mbok], 0);
end;

procedure TFormCargas.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  tc.Close;
  db.Close;
  action := cafree;
end;

procedure TFormCargas.FormShow(Sender: TObject);
begin
  txtruta.text := extractfilepath(application.exename) + 'cargas\cargas.mdb';
  datos.TCuadrilla.Filtered := false;
  datos.TCuadrilla.Open;
  if datos.TCuadrilla.RecordCount > 0 then
    txtcuadrilla.KeyValue := Datos.TCuadrilla.fieldbyname('Codigo').Value;
end;

procedure TFormCargas.txtQuincenaChange(Sender: TObject);
begin
  BitBtn2.Enabled := false;
end;

procedure TFormCargas.txtObreroChange(Sender: TObject);
begin
  BitBtn2.Enabled := false;
end;

procedure TFormCargas.txtRutaChange(Sender: TObject);
begin
  BitBtn2.Enabled := false;
end;

procedure TFormCargas.opQuincenaClick(Sender: TObject);
begin
  BitBtn2.Enabled := false;
end;

procedure TFormCargas.opObrerosClick(Sender: TObject);
begin
  BitBtn2.Enabled := false;
end;

procedure TFormCargas.txtRutaMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  txtruta.Hint := txtRuta.Text;
end;

procedure TFormCargas.txtFechaPagoChange(Sender: TObject);
begin
  BitBtn2.Enabled := false;
end;

procedure TFormCargas.txtPeriodoChange(Sender: TObject);
begin
  BitBtn2.Enabled := false;
end;

procedure TFormCargas.BGuardarErroresClick(Sender: TObject);
begin
  DLGuardar.Title := 'Guardar errores de carga...';
  DLGuardar.filename := 'Errores de carga';
  if DLGuardar.Execute then
    txterrores.Lines.SaveToFile(dlguardar.FileName);
end;

procedure TFormCargas.BitBtn4Click(Sender: TObject);
begin
  txtErrores.SelectAll;
  txterrores.CopyToClipboard;
end;

end.
