unit UnidadCuadrilla;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ActnList, StdCtrls, ExtCtrls, ComCtrls, ToolWin, DBCtrls, Mask,
  Buttons, Grids, DBGrids, Db, DBTables, inifiles,Variants;

type
  TformCuadrillas = class(TForm)
    PopupMenu1: TPopupMenu;
    ActionList1: TActionList;
    CB: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ActNuevo: TAction;
    ActEliminar: TAction;
    ActModificar: TAction;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ActRefrescar: TAction;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ActCerrar: TAction;
    Tabla: TDBGrid;
    ActImprimir: TAction;
    Aadir1: TMenuItem;
    Eliminar1: TMenuItem;
    Modificar1: TMenuItem;
    N1: TMenuItem;
    Refrescar1: TMenuItem;
    N2: TMenuItem;
    Cerrar1: TMenuItem;
    ToolButton8: TToolButton;
    ActBuscar: TAction;
    ToolButton9: TToolButton;
    Buscar1: TMenuItem;
    Imprimir1: TMenuItem;
    ActZoom: TAction;
    ToolButton10: TToolButton;
    Zoom1: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ActNuevoExecute(Sender: TObject);
    procedure ActEliminarExecute(Sender: TObject);
    procedure TablaKeyPress(Sender: TObject; var Key: Char);
    procedure ActModificarExecute(Sender: TObject);
    procedure TablaDblClick(Sender: TObject);
    procedure ActRefrescarExecute(Sender: TObject);
    procedure ActCerrarExecute(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ActImprimirExecute(Sender: TObject);
    procedure ActBuscarExecute(Sender: TObject);
    procedure ActZoomExecute(Sender: TObject);
    procedure TablaTitleClick(Column: TColumn);

    procedure ordenar (campo : string; campoFijo : string);


  private
    campoOrdenado : string;
    nombreCampoOrdenado : string;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formCuadrillas: TformCuadrillas;
const
  ventana = 'Cuadrilla';
  ventanas = 'Cuadrillas';
  segCampo =  'Nombre';

implementation

uses UnidadMenuPrincipal, UnidadImprimir,
  UnidadLocalizar, UnidadDatos, UnidadGCuadrilla;

{$R *.DFM}

procedure tformCuadrillas.ordenar (campo : string; campoFijo : string);
var
  lugar : string;
begin
  lugar := '';
  with datos.tcCuadrilla do
  begin
    if Active then
    begin
      Refresh;
      if RecordCount > 0 then
        lugar := fieldbyname('Codigo').value;
    end;
    close;
    sql.clear;
    sql.add ('SELECT *');
    sql.add ('FROM ' + ctCuadrilla);
    sql.add ('ORDER BY ' + campo + ',' + campoFijo);
    try
      open;
    except
      raise;
    end;
    if lugar <> '' then
      locate ('Codigo', lugar, []);
  end;
end;

procedure TformCuadrillas.FormClose(Sender: TObject;
  var Action: TCloseAction);
var
  i:integer;
begin
  //Guardar el ancho de las columnas y configuracin
  with TIniFile.Create(ChangeFileExt(ParamStr(0), '.INI')) do
  try
    WriteString('Tabla ' + ventanas, 'Posicion', datos.TCCuadrillaCodigo.value);
    writestring('Tabla ' + ventanas, 'Ordenado', campoOrdenado);
    writestring('Tabla ' + ventanas, 'CampoOrdenado', nombreCampoOrdenado);
    for I := 0 to tabla.Columns.Count - 1 do
    begin
      with tabla.Columns.Items[I] do
        WriteInteger('Tabla ' + ventanas, FieldName, Width);
    end;
  finally
    Free;
  end;
  try
   datos.tcCuadrilla.close;
  finally
    screen.cursor := crdefault;
    action := cafree;
  end;
end;

procedure TformCuadrillas.FormShow(Sender: TObject);
var
  lugar : string;
  i : integer;
begin
  with TIniFile.Create(ChangeFileExt(ParamStr(0), '.INI')) do
  try
    lugar := readString('Tabla ' + ventanas, 'Posicion', '0');
    campoOrdenado := readstring('Tabla ' + ventanas, 'Ordenado', 'Codigo');
    nombreCampoOrdenado := readstring('Tabla ' + ventanas, 'CampoOrdenado', 'Cdigo');
    if campoOrdenado = '' then
      campoOrdenado := 'Codigo';
    if nombreCampoOrdenado = '' then
      nombreCampoOrdenado := 'Cdigo';
  finally
    Free;
  end;
  ordenar(campoOrdenado, segCampo);
  Datos.TCCuadrilla.Locate ('Codigo', lugar, []);

  //ancho de columnas
  with TIniFile.Create(ChangeFileExt(ParamStr(0), '.INI')) do
  try
    for I := 0 to tabla.Columns.Count - 1 do
      with tabla.Columns.Items[I] do
        Width := ReadInteger('Tabla ' + ventanas, FieldName, Width);
  finally
    Free;
  end;

  actcerrar.Hint := 'Cerrar ' + ventanas;
  caption := ventanas + ' (ordenado por ' + nombrecampoordenado + ')';
  screen.cursor := crdefault;
end;

procedure TformCuadrillas.FormCreate(Sender: TObject);
var
  I: Integer;
begin
  campoOrdenado := 'codigo';
  ordenar(campoOrdenado, 'nombre');
  with TIniFile.Create(ChangeFileExt(ParamStr(0), '.INI')) do
  try
    for I := 0 to tabla.Columns.Count - 1 do
      with tabla.Columns.Items[I] do
        Width := ReadInteger('Tabla ' + ventanas, FieldName, Width);
  finally
    Free;
  end;
  actcerrar.Hint := 'Cerrar ' + ventanas;
  caption := ventanas;
end;

procedure TformCuadrillas.ActNuevoExecute(Sender: TObject);
begin
  formmenuprincipal.accion := 'nuevo';
  application.createform(tformCuadrillag, formCuadrillag);
  formCuadrillag.ShowModal;
  ActRefrescarExecute(nil);
end;

procedure TformCuadrillas.ActEliminarExecute(Sender: TObject);
var
  nombre : String;
begin
  if datos.tcCuadrilla.RecordCount <= 0 then
    messagedlg ('No hay datos.', mtinformation,[mbok],0)
  else
  begin
    datos.tc.close;
    datos.tc.DatabaseName := 'Pagos';
    datos.tc.sql.clear;
    datos.tc.sql.add('SELECT CodigoCuadrilla');
    datos.tc.sql.add('FROM ' + ctEmpleado);
    datos.tc.sql.add('WHERE CodigoCuadrilla = "' + datos.TCCuadrillaCodigo.value + '"');
    datos.tc.open;
    if datos.tc.RecordCount > 0 then
    begin
      datos.tc.close;
      messagedlg ('No se puede eliminar la ' + ventana +
          ' ya que existe en empleados.', mterror,[mbok],0);
      exit;
    end;
    datos.tc.close;
    datos.tCuadrilla.Active := true;
    datos.tCuadrilla.locate('Codigo',
        datos.tcCuadrilla.fieldbyname('Codigo').value, []);
    if not varisnull(datos.tcCuadrillaNombre.Value) then
      nombre := datos.tcCuadrillaNombre.Value
    else
      nombre := '';
    if messagedlg ('Est seguro que desea eliminar la ' + ventana + ' : ' +
        nombre + '?', mtconfirmation,[mbyes,mbno],0)=mryes then
    begin
      try
        datos.tCuadrilla.delete;
        ActRefrescarExecute(nil);
      except
        raise;
      end;
    end;
  end;
end;

procedure TformCuadrillas.TablaKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = chr(13) then
    ActModificarExecute(nil);
end;

procedure TformCuadrillas.ActModificarExecute(Sender: TObject);
begin
  if datos.tcCuadrilla.RecordCount <= 0 then
    messagedlg ('No hay datos.', mtinformation,[mbok],0)
  else
  begin
    if not varisnull(datos.tcCuadrilla.fieldbyname('Codigo').value) then
    begin
      formmenuprincipal.accion := 'modificar';
      datos.tCuadrilla.Active := true;
      datos.tCuadrilla.locate ('Codigo',
          datos.tcCuadrilla.fieldbyname('Codigo').value,[]);
      datos.tCuadrilla.edit;
      application.createform(tformCuadrillag, formCuadrillag);
      formCuadrillag.ShowModal;
      ActRefrescarExecute(nil);
    end
    else
      messagedlg ('Atencin, el ' + ventana + ' actual no tiene cdigo, ' +
          'elimnelo antes de continuar.',mtinformation,[mbok],0);
  end;
end;

procedure TformCuadrillas.TablaDblClick(Sender: TObject);
begin
  ActModificarExecute(nil);
end;

procedure TformCuadrillas.ActRefrescarExecute(Sender: TObject);
begin
  ordenar(campoOrdenado, 'nombre');
end;

procedure TformCuadrillas.ActCerrarExecute(Sender: TObject);
begin
  close;
end;

procedure TformCuadrillas.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key = '-' then
    ActEliminarExecute(nil);
  if key = '+' then
    ActNuevoExecute(nil);
  if key = '*' then
    ActModificarExecute(nil);
  if key = chr(27) then  //escape
    ActCerrarExecute(nil);
end;

procedure TformCuadrillas.ActImprimirExecute(Sender: TObject);
begin
  if datos.tcCuadrilla.RecordCount <= 0 then
    messagedlg ('No hay datos.', mtinformation,[mbok],0)
  else
  begin
    application.createform(tformImprimir, formImprimir);
    formimprimir.Tag := 30;
    formImprimir.showmodal;
  end;
end;

procedure TformCuadrillas.ActBuscarExecute(Sender: TObject);
begin
  if datos.tcCuadrilla.RecordCount <= 0 then
    messagedlg ('No hay datos.', mtinformation,[mbok],0)
  else
  begin
    application.createform(tformLocalizar, formLocalizar);
    FormLocalizar.Tag := 30;
    formLocalizar.showmodal;
  end;
end;

procedure TformCuadrillas.ActZoomExecute(Sender: TObject);
begin
  if datos.tcCuadrilla.RecordCount <= 0 then
    messagedlg ('No hay datos.', mtinformation,[mbok],0)
  else
  begin
    formmenuprincipal.accion := 'zoom';
    formmenuprincipal.codigo := datos.tcCuadrilla.fieldbyname('Codigo').value;
    application.createform(tformCuadrillag, formCuadrillag);
    formCuadrillag.ShowModal;
  end;
end;

procedure TformCuadrillas.TablaTitleClick(Column: TColumn);
begin
  campoOrdenado := column.fieldname;
  nombreCampoOrdenado := Column.Title.Caption;
  caption := ventanas + ' (ordenado por ' + Column.Title.Caption + ')';
  ordenar (campoOrdenado, 'nombre');
end;

end.
