unit UnidadGCuadrilla;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, DBCtrls, Mask, Buttons, ExtCtrls, db;

type
  TFormCuadrillaG = class(TForm)
    TxtNombre: TDBEdit;
    Panel1: TPanel;
    TxtCodigo: TDBEdit;
    BCancelar: TBitBtn;
    BAceptar: TBitBtn;
    DBMemo1: TDBMemo;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure BCancelarClick(Sender: TObject);
    procedure BAceptarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure TxtCodigoExit(Sender: TObject);
    procedure TxtNombreExit(Sender: TObject);
    procedure DBEdit7KeyPress(Sender: TObject; var Key: Char);
    procedure DBEdit13KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormCuadrillaG: TFormCuadrillaG;
const
  ventana = 'Cuadrilla';
  ventanas = 'Cuadrillas';

implementation

uses UnidadDatos, UnidadMenuPrincipal, UnidadCalendario;

{$R *.DFM}

procedure TFormCuadrillaG.BCancelarClick(Sender: TObject);
begin
  try
    datos.TCuadrilla.cancel;
  except
    //silenciosa
  end;
  close;
end;

procedure TFormCuadrillaG.BAceptarClick(Sender: TObject);
begin
  if (TxtCodigo.Text = '') then
  begin
    messagedlg ('Debe introducir el cdigo de la ' + ventana,
        mtinformation,[mbok],0);
    txtcodigo.setfocus;
    exit;
  end;
  if (TxtNombre.Text = '') then
  begin
    messagedlg ('Debe introducir el nombre de la ' + ventana,
        mtinformation, [mbok], 0);
    txtnombre.setfocus;
    exit;
  end;
  if datos.TCuadrilla.State  in [dsinsert, dsedit] then
  begin
    try
      datos.TCuadrilla.Post; //validar
    except
      txtnombre.setfocus;
      raise;
    end;
  end;
  close;
end;

procedure TFormCuadrillaG.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  action := cafree;
end;                                                                                                                                                                                                                                                                                                                                                                      

procedure TFormCuadrillaG.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    Key := #0;
    Perform(WM_NEXTDLGCTL, 0, 0);
  end;
end;

procedure TFormCuadrillaG.FormShow(Sender: TObject);
begin
  datos.tCuadrilla.open;
  if formmenuprincipal.accion = 'nuevo' then
  begin
    caption := 'Nuevo ' + ventana + '...';
    datos.TCuadrilla.Insert;
  end;
  if formmenuprincipal.accion = 'modificar' then
  begin
    txtcodigo.Enabled := false;
    caption := 'Modificar ' + ventana + '...';
  end;
  if formmenuprincipal.accion = 'zoom' then
  begin
    datos.TCuadrilla.locate ('Codigo', formmenuprincipal.codigo,[]);
    caption := 'Visualizar ' + ventana + '...';
    baceptar.Visible := false;
    bcancelar.SetFocus;
  end;
end;

procedure TFormCuadrillaG.TxtCodigoExit(Sender: TObject);
begin
  if (formmenuprincipal.accion = 'nuevo') then
  begin
    if txtcodigo.text = '' then
    begin
      messagedlg ('El cdigo debe contener un valor.', mterror,[mbok],0);
      txtcodigo.SelectAll;
      txtcodigo.setfocus;
      exit;
    end;
    if formmenuprincipal.accion = 'nuevo' then
    begin
      datos.tc.close;
      datos.tc.DatabaseName := 'Pagos';
      datos.tc.sql.Clear;
      datos.tc.SQL.add('SELECT count(Codigo) C FROM ' + ctCuadrilla);
      datos.tc.sql.add('WHERE codigo = "' + txtcodigo.text + '"');
      datos.tc.open;
      if datos.tc.fieldbyname('C').value > 0 then
      begin
        messagedlg ('Ya existe un ' + ventana + ' con este Cdigo.',
            mtError,[mbok],0);
        txtcodigo.SelectAll;
        txtcodigo.setfocus;
        exit;
      end;
      datos.tc.Close;
    end;
  end;
end;

procedure TFormCuadrillaG.TxtNombreExit(Sender: TObject);
begin
  if (formmenuprincipal.accion = 'modificar') or
      (formmenuprincipal.accion = 'nuevo') then
  begin
    if formmenuprincipal.accion = 'nuevo' then
    begin
      datos.tc.close;
      datos.tc.DatabaseName := 'Pagos';
      datos.tc.sql.Clear;
      datos.tc.SQL.add('SELECT count(Nombre) C FROM ' + ctCuadrilla);
      datos.tc.sql.add('WHERE Nombre = "' + txtnombre.text + '"');
      datos.tc.open;
      if datos.tc.fieldbyname('C').value > 0 then
      begin
        messagedlg ('Ya existe una ' + ventana + ' con este Nombre.',
            mterror,[mbok],0);
        txtnombre.SelectAll;
        txtnombre.setfocus;
        exit;
      end;
      datos.tc.Close;
    end;
  end;
end;

procedure TFormCuadrillaG.DBEdit7KeyPress(Sender: TObject; var Key: Char);
begin
  if key = '.' then
    key := ',';
end;

procedure TFormCuadrillaG.DBEdit13KeyPress(Sender: TObject; var Key: Char);
begin
  if key = '.' then
    key := ',';
end;

end.
