unit UnidadGPagos;

interface

uses
  Messages, SysUtils, Classes, Graphics, Controls,  Dialogs,
  StdCtrls, DBCtrls, Buttons, ExtCtrls, db, DBTables, Mask, forms, ComCtrls, variants;

type
  TFormPagoG = class(TForm)
    TxtCodigo: TDBEdit;
    Label8: TLabel;
    Label10: TLabel;
    BAceptar: TBitBtn;
    BCancelar: TBitBtn;
    Panel1: TPanel;
    Label3: TLabel;
    TxtFecha: TDBEdit;
    Label5: TLabel;
    DBEdit4: TDBEdit;
    BSeleccionarFecha: TSpeedButton;
    Label11: TLabel;
    TxtCodigoEmpleado: TDBEdit;
    BSeleccionar: TSpeedButton;
    DBText1: TDBText;
    DBEdit3: TDBEdit;
    Label4: TLabel;
    DBEdit1: TDBEdit;
    Label1: TLabel;
    DBRichEdit1: TDBRichEdit;
    BCalcular: TBitBtn;
    Label2: TLabel;
    DBEdit2: TDBEdit;
    procedure BCancelarClick(Sender: TObject);
    procedure BAceptarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure TxtCodigoKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure BSeleccionarFechaClick(Sender: TObject);
    procedure TxtFechaKeyPress(Sender: TObject; var Key: Char);
    procedure BSeleccionarClick(Sender: TObject);
    procedure TxtCodigoEmpleadoKeyPress(Sender: TObject; var Key: Char);
    procedure DBEdit4KeyPress(Sender: TObject; var Key: Char);
    procedure DBEdit3KeyPress(Sender: TObject; var Key: Char);
    procedure DBEdit1KeyPress(Sender: TObject; var Key: Char);
    procedure BCalcularClick(Sender: TObject);
    procedure calcularBilletes(Cantidad : double);
    procedure DBEdit4Change(Sender: TObject);

    function Redondear (Numero : Double; PrecisionDec : byte) : double;

  private
    modificado : boolean;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormPagoG: TFormPagoG;
const
  ventana = 'Pago';
  ventanas = 'Pagos';

implementation

uses UnidadDatos, UnidadMenuPrincipal, UnidadSeleccion, UnidadCalendario;


{$R *.DFM}

procedure TformPagoG.calcularBilletes(Cantidad : double);
var
  C : array[1..15] of double;
  S : array[1..15] of double;
  i : integer;
begin
  try
    c[1] := 50000;
    c[2] := 20000;
    c[3] := 10000;
    c[4] := 5000;
    c[5] := 2000;
    c[6] := 1000;
    c[7] := 500;
    c[8] := 200;
    c[9] := 100;
    c[10] := 50;
    c[11] := 20;
    c[12] := 10;
    c[13] := 5;
    c[14] := 2;
    c[15] := 1;

    //Pasa el total a pagar a cntimos
    cantidad := cantidad * 100;
    cantidad := int(cantidad);
    for i := 1 to 15 do
    begin
      s[i] := int(cantidad / c[i]);
      cantidad := cantidad - s[i] * c[i];
    end;
    Datos.TPagos.FieldByName('1C').value := s[15];
    Datos.TPagos.FieldByName('2C').value := s[14];
    Datos.TPagos.FieldByName('5C').value := s[13];
    Datos.TPagos.FieldByName('10C').value := s[12];
    Datos.TPagos.FieldByName('20C').value := s[11];
    Datos.TPagos.FieldByName('50C').value := s[10];
    Datos.TPagos.FieldByName('1E').value := s[9];
    Datos.TPagos.FieldByName('2E').value := s[8];
    Datos.TPagos.FieldByName('5E').value := s[7];
    Datos.TPagos.FieldByName('10E').value := s[6];
    Datos.TPagos.FieldByName('20E').value := s[5];
    Datos.TPagos.FieldByName('50E').value := s[4];
    Datos.TPagos.FieldByName('100E').value := s[3];
    Datos.TPagos.FieldByName('200E').value := s[2];
    Datos.TPagos.FieldByName('500E').value := s[1];
  except
    //Silenciosa
  end;
end;










procedure TFormPagoG.BCancelarClick(Sender: TObject);
begin
  try
    datos.TPagos.cancel;
  except
    //silenciosa
  end;
  close;
end;

procedure TFormPagoG.BAceptarClick(Sender: TObject);
begin
  if datos.TPagosNombre.Value = '' then
  begin
    messagedlg ('No existe ningn empleado con el cdigo: ' +
        Txtcodigoempleado.text + '.', mterror,[mbok],0);
    TxtCodigoempleado.SelectAll;
    TxtCodigoempleado.setfocus;
    exit;
  end;
  if modificado then
  begin
    MessageDlg('Ha modificado las cantidades, pulse el botn ' +
         'Calcular billetes" para actualizar los datos.',mtwarning,[mbok],0);
    BCalcular.SetFocus;
    exit;
  end;
  if datos.tpagos.State  in [dsinsert, dsedit] then
  begin
    try
      datos.tpagos.Post; //validar
    except
      txtfecha.setfocus;
      raise;
    end;
  end;
  close;
end;

procedure TFormPagoG.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  datos.TC.close;
  action := cafree;
end;

procedure TFormPagoG.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    Key := #0;
    Perform(WM_NEXTDLGCTL, 0, 0);
  end;
end;

procedure TFormPagoG.TxtCodigoKeyPress(Sender: TObject;
  var Key: Char);
begin
  if FormMenuPrincipal.accion <> 'zoom' then
  begin
    if key = '+' then
    begin
      key := chr(0);
      BSeleccionarclick(nil);
    end;
  end;
end;

procedure TFormPagoG.FormShow(Sender: TObject);
begin
  Datos.Tpagos.open;
  if formmenuprincipal.accion = 'nuevo' then
  begin
    caption := 'Nuevo ' + ventana + '...';
    datos.TPagos.Active := true;
    datos.tpagos.Insert;
  end;
  if formmenuprincipal.accion = 'modificar' then
  begin
    txtcodigo.Enabled := false;
    bseleccionar.Visible := false;
    caption := 'Modificar ' + ventana + '...';
  end;
  if formmenuprincipal.accion = 'zoom' then
  begin
    datos.tpagos.Active := true;
    datos.tpagos.locate ('Codigo', formmenuprincipal.codigo,[]);
    caption := 'Visualizar ' + ventana + '...';
    bseleccionar.Visible := false;
    bseleccionarfecha.Visible := false;
    bseleccionar.Visible := false;
    baceptar.Visible := false;
    bcancelar.SetFocus;
    BCalcular.Visible := false;
  end;
  modificado := false;
end;

procedure TFormPagoG.BSeleccionarFechaClick(Sender: TObject);
begin
  application.createform(tformCalendario, formCalendario);
  formCalendario.ShowModal;
  if formmenuprincipal.claveelegida <> '' then
    if FormMenuPrincipal.claveelegida <> '' then
      TxtFecha.Text := formmenuprincipal.claveelegida;
end;

procedure TFormPagoG.TxtFechaKeyPress(Sender: TObject; var Key: Char);
begin
  if FormMenuPrincipal.accion <> 'zoom' then
  begin
    if key = '+' then
    begin
      key := chr(0);
      BSeleccionarFechaclick(nil);
    end;
  end;
end;

procedure TFormPagoG.BSeleccionarClick(Sender: TObject);
begin
  application.createform(tformseleccion, formseleccion);
  formseleccion.ActNuevo.Enabled := true;
  formseleccion.tag := 10;
  formseleccion.ShowModal;
  if formmenuprincipal.claveelegida <> '' then
    TxtCodigoEmpleado.Text := formmenuprincipal.claveelegida;
  datos.DPagos.DataSet.edit;
end;

procedure TFormPagoG.TxtCodigoEmpleadoKeyPress(Sender: TObject;
  var Key: Char);
begin
  if FormMenuPrincipal.accion <> 'zoom' then
  begin
    if key = '+' then
    begin
      key := chr(0);
      BSeleccionarClick(nil);
    end;
  end;
end;

procedure TFormPagoG.DBEdit4KeyPress(Sender: TObject; var Key: Char);
begin
  if key = '.' then
    key := ',';
end;

procedure TFormPagoG.DBEdit3KeyPress(Sender: TObject; var Key: Char);
begin
  if key = '.' then
    key := ',';
end;

procedure TFormPagoG.DBEdit1KeyPress(Sender: TObject; var Key: Char);
begin
  if key = '.' then
    key := ',';
end;

function TFormPagoG.Redondear (Numero : Double; PrecisionDec : byte) : double;
  function Potencia(Base : Double; Exponente : byte) : Double;
  begin
    Result := Exp(Exponente * ln(Base));
  end;
begin
  result := Round(Numero * Potencia(10, PrecisionDec)) / Potencia (10, PrecisionDec);
end;

procedure TFormPagoG.BCalcularClick(Sender: TObject);
var
  horas, precioHora, sueldo : double;
begin
  if varisnull(Datos.TPagosHORAS.Value) then
    horas := 0
  else
    horas := Datos.TPagosHORAS.Value;
  if varisnull(Datos.TPagosPRECIOHORA.Value) then
    precioHora := 0
  else
    precioHora := Datos.TPagosPRECIOHORA.Value;
  if varisnull(Datos.TPagosSUELDO.Value) then
    sueldo := 0
  else
    sueldo := Datos.TPagosSUELDO.Value;

  if (horas <> 0) and (precioHora <> 0) then
  begin
    sueldo := horas * precioHora;
  end;
  sueldo := redondear(sueldo,2);
  datos.TPagosSUELDO.Value := sueldo;
  datos.TPagosBILLETES.Value := formMenuPrincipal.calcularBilletes(datos.TPagosSUELDO.Value);
  calcularBilletes(datos.TPagosSUELDO.Value);
  modificado := false;
end;

procedure TFormPagoG.DBEdit4Change(Sender: TObject);
begin
  modificado := true;
end;

end.
