unit UnidadPagos;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ActnList, StdCtrls, ExtCtrls, ComCtrls, ToolWin, DBCtrls, Mask,
  Buttons, Grids, DBGrids, Db, DBTables, inifiles,Variants;

type
  TformPagos = class(TForm)
    PopupMenu1: TPopupMenu;
    ActionList1: TActionList;
    CB: TControlBar;
    BB: TToolBar;
    ToolButton1: TToolButton;
    ActNuevo: TAction;
    ActEliminar: TAction;
    ActModificar: TAction;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ActRefrescar: TAction;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ActCerrar: TAction;
    Tabla: TDBGrid;
    ActImprimir: TAction;
    Aadir1: TMenuItem;
    Eliminar1: TMenuItem;
    Modificar1: TMenuItem;
    N1: TMenuItem;
    Refrescar1: TMenuItem;
    N2: TMenuItem;
    Cerrar1: TMenuItem;
    ToolButton8: TToolButton;
    ActBuscar: TAction;
    ToolButton9: TToolButton;
    Buscar1: TMenuItem;
    Imprimir1: TMenuItem;
    ActZoom: TAction;
    ToolButton10: TToolButton;
    Zoom1: TMenuItem;
    actCalcular: TAction;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ActNuevoExecute(Sender: TObject);
    procedure ActEliminarExecute(Sender: TObject);
    procedure TablaKeyPress(Sender: TObject; var Key: Char);
    procedure ActModificarExecute(Sender: TObject);
    procedure TablaDblClick(Sender: TObject);
    procedure ActRefrescarExecute(Sender: TObject);
    procedure ActCerrarExecute(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ActImprimirExecute(Sender: TObject);
    procedure ActBuscarExecute(Sender: TObject);
    procedure ActZoomExecute(Sender: TObject);
    procedure TablaTitleClick(Column: TColumn);

    procedure ordenar (campo : string; campoFijo : string);


  private
    campoOrdenado : string;
    nombreCampoOrdenado : string;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formPagos: TformPagos;
const
  ventana = 'Pago';
  ventanas = 'Pagos';
  segCampo =  'Nombre';

implementation

uses UnidadMenuPrincipal, UnidadImprimir,
  UnidadLocalizar, UnidadDatos, UnidadGPagos;

{$R *.DFM}

procedure tformPagos.ordenar (campo : string; campoFijo : string);
var
  lugar : string;
begin
  lugar := '';
  with datos.TCPagos do
  begin
    if Active then
    begin
      Refresh;
      if RecordCount > 0 then
        lugar := fieldbyname('Codigo').value;
    end;
    close;
    sql.Clear;
    sql.add ('select p.*, e.Nombre Nombre');
    sql.add ('from ' + ctPagos + ' p, ' + ctEmpleado  + ' e');
    sql.add ('where p.CodigoEmpleado = e.Codigo');
    sql.add ('order by ' + campo + ', ' +  campofijo);
    try
      open;
    except
      raise;
    end;
    if lugar <> '' then
      locate ('Codigo', lugar, []);
  end;
end;

procedure TformPagos.FormClose(Sender: TObject;
  var Action: TCloseAction);
var
  i:integer;
begin
  //Guardar el ancho de las columnas y configuracin
  with TIniFile.Create(ChangeFileExt(ParamStr(0), '.INI')) do
  try
    WriteInteger('Tabla ' + ventanas, 'Posicion', datos.TCPagosCodigo.value);
    writestring('Tabla ' + ventanas, 'Ordenado', campoOrdenado);
    writestring('Tabla ' + ventanas, 'CampoOrdenado', nombreCampoOrdenado);
    for I := 0 to tabla.Columns.Count - 1 do
    begin
      with tabla.Columns.Items[I] do
        WriteInteger('Tabla ' + ventanas, FieldName, Width);
    end;
  finally
    Free;
  end;
  try
   datos.TCPagos.close;
  finally
    screen.cursor := crdefault;
    action := cafree;
  end;
end;

procedure TformPagos.FormShow(Sender: TObject);
var
  lugar : string;
  i : integer;
begin
  with TIniFile.Create(ChangeFileExt(ParamStr(0), '.INI')) do
  try
    lugar := readString('Tabla ' + ventanas, 'Posicion', '0');
    campoOrdenado := readstring('Tabla ' + ventanas, 'Ordenado', 'Codigo');
    nombreCampoOrdenado := readstring('Tabla ' + ventanas, 'CampoOrdenado', 'Cdigo');
    if campoOrdenado = '' then
      campoOrdenado := 'Codigo';
    if nombreCampoOrdenado = '' then
      nombreCampoOrdenado := 'Cdigo';
  finally
    Free;
  end;
  ordenar(campoOrdenado, segCampo);
  Datos.TCPagos.Locate ('Codigo', lugar, []);

  //ancho de columnas
  with TIniFile.Create(ChangeFileExt(ParamStr(0), '.INI')) do
  try
    for I := 0 to tabla.Columns.Count - 1 do
      with tabla.Columns.Items[I] do
        Width := ReadInteger('Tabla ' + ventanas, FieldName, Width);
  finally
    Free;
  end;

  actcerrar.Hint := 'Cerrar ' + ventanas;
  caption := ventanas + ' (ordenado por ' + nombrecampoordenado + ')';
  screen.cursor := crdefault;
end;

procedure TformPagos.FormCreate(Sender: TObject);
var
  I: Integer;
begin
  campoOrdenado := 'codigo';
  ordenar(campoOrdenado, 'nombre');
  with TIniFile.Create(ChangeFileExt(ParamStr(0), '.INI')) do
  try
    for I := 0 to tabla.Columns.Count - 1 do
      with tabla.Columns.Items[I] do
        Width := ReadInteger('Tabla ' + ventanas, FieldName, Width);
  finally
    Free;
  end;
  actcerrar.Hint := 'Cerrar ' + ventanas;
  caption := ventanas;
end;

procedure TformPagos.ActNuevoExecute(Sender: TObject);
begin
  formmenuprincipal.accion := 'nuevo';
  application.createform(TFormPagoG, formPagog);
  formPagog.ShowModal;
  ActRefrescarExecute(nil);
end;

procedure TformPagos.ActEliminarExecute(Sender: TObject);
var
  nombre : String;
begin
  if datos.TCPagos.RecordCount <= 0 then
    messagedlg ('No hay datos.', mtinformation,[mbok],0)
  else
  begin
    datos.tc.close;
    datos.TPagos.Active := true;
    datos.TPagos.locate('Codigo',
        datos.TCPagos.fieldbyname('Codigo').value, []);
    if not varisnull(datos.TCPagosNombre.Value) then
      nombre := datos.TCPagosNombre.Value
    else
      nombre := '';
    if messagedlg ('Est seguro que desea eliminar el ' + ventana + ' de: ' +
        nombre + '?', mtconfirmation,[mbyes,mbno],0)=mryes then
    begin
      try
        datos.TPagos.delete;
        ActRefrescarExecute(nil);
      except
        raise;
      end;
    end;
  end;
end;

procedure TformPagos.TablaKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = chr(13) then
    ActModificarExecute(nil);
end;

procedure TformPagos.ActModificarExecute(Sender: TObject);
begin
  if datos.TCPagos.RecordCount <= 0 then
    messagedlg ('No hay datos.', mtinformation,[mbok],0)
  else
  begin
    if not varisnull(datos.TCPagos.fieldbyname('Codigo').value) then
    begin
      formmenuprincipal.accion := 'modificar';
      datos.TPagos.Active := true;
      datos.TPagos.locate ('Codigo',
          datos.TCPagos.fieldbyname('Codigo').value,[]);
      datos.TPagos.edit;
      application.createform(TFormPagoG, FormPagoG);
      formPagog.ShowModal;
      ActRefrescarExecute(nil);
    end
    else
      messagedlg ('Atencin, el ' + ventana + ' actual no tiene cdigo, ' +
          'elimnelo antes de continuar.',mtinformation,[mbok],0);
  end;
end;

procedure TformPagos.TablaDblClick(Sender: TObject);
begin
  ActModificarExecute(nil);
end;

procedure TformPagos.ActRefrescarExecute(Sender: TObject);
begin
  ordenar(campoOrdenado, 'nombre');
end;

procedure TformPagos.ActCerrarExecute(Sender: TObject);
begin
  close;
end;

procedure TformPagos.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key = '-' then
    ActEliminarExecute(nil);
  if key = '+' then
    ActNuevoExecute(nil);
  if key = '*' then
    ActModificarExecute(nil);
  if key = chr(27) then  //escape
    ActCerrarExecute(nil);
end;

procedure TformPagos.ActImprimirExecute(Sender: TObject);
begin
  if datos.TCPagos.RecordCount <= 0 then
    messagedlg ('No hay datos.', mtinformation,[mbok],0)
  else
  begin
    application.createform(tformImprimir, formImprimir);
    formimprimir.Tag := 20;
    formImprimir.showmodal;
  end;
end;

procedure TformPagos.ActBuscarExecute(Sender: TObject);
begin
  if datos.TCPagos.RecordCount <= 0 then
    messagedlg ('No hay datos.', mtinformation,[mbok],0)
  else
  begin
    application.createform(tformLocalizar, formLocalizar);
    FormLocalizar.Tag := 20;
    formLocalizar.showmodal;
  end;
end;

procedure TformPagos.ActZoomExecute(Sender: TObject);
begin
  if datos.TCPagos.RecordCount <= 0 then
    messagedlg ('No hay datos.', mtinformation,[mbok],0)
  else
  begin
    formmenuprincipal.accion := 'zoom';
    formmenuprincipal.codigo := datos.TCPagos.fieldbyname('Codigo').value;
    application.createform(TFormPagoG, FormPagoG);
    FormPagoG.ShowModal;
  end;
end;

procedure TformPagos.TablaTitleClick(Column: TColumn);
begin
  campoOrdenado := column.fieldname;
  nombreCampoOrdenado := Column.Title.Caption;
  caption := ventanas + ' (ordenado por ' + Column.Title.Caption + ')';
  ordenar (campoOrdenado, 'nombre');
end;

end.
